#define NRANSI
#include "nrutil.h"

#ifndef INDEXX_SWAP
#define INDEXX_SWAP(a,b) itemp=(a);(a)=(b);(b)=itemp;
#endif
#ifndef INDEXX_M
#define INDEXX_M 7
#endif
#ifndef INDEXX_NSTACK
#define INDEXX_NSTACK 50
#endif

void indexx_ov_d_ul(unsigned long n, double arr[], unsigned long indx[])
     /* indexx with its own internal variables
      * a variable having a name like M should not be changed by an
      * auxiliary routine !  
      * using double and unsigned long arithmetic
      */
{
	unsigned long i,indxt,ir=n,itemp,j,k,l=1;
	unsigned long jstack=0,*istack;
	double a;

	istack=lvector(1,INDEXX_NSTACK);
	for (j=1;j<=n;j++) indx[j]=j;
	for (;;) {
		if (ir-l < INDEXX_M) {
			for (j=l+1;j<=ir;j++) {
				indxt=indx[j];
				a=arr[indxt];
				for (i=j-1;i>=1;i--) {
					if (arr[indx[i]] <= a) break;
					indx[i+1]=indx[i];
				}
				indx[i+1]=indxt;
			}
			if (jstack == 0) break;
			ir=istack[jstack--];
			l=istack[jstack--];
		} else {
			k=(l+ir) >> 1;
			INDEXX_SWAP(indx[k],indx[l+1]);
			if (arr[indx[l+1]] > arr[indx[ir]]) {
				INDEXX_SWAP(indx[l+1],indx[ir])
			}
			if (arr[indx[l]] > arr[indx[ir]]) {
				INDEXX_SWAP(indx[l],indx[ir])
			}
			if (arr[indx[l+1]] > arr[indx[l]]) {
				INDEXX_SWAP(indx[l+1],indx[l])
			}
			i=l+1;
			j=ir;
			indxt=indx[l];
			a=arr[indxt];
			for (;;) {
				do i++; while (arr[indx[i]] < a);
				do j--; while (arr[indx[j]] > a);
				if (j < i) break;
				INDEXX_SWAP(indx[i],indx[j])
			}
			indx[l]=indx[j];
			indx[j]=indxt;
			jstack += 2;
			if (jstack > INDEXX_NSTACK) nrerror("INDEXX_NSTACK too small in indexx.");
			if (ir-i+1 >= j-l) {
				istack[jstack]=ir;
				istack[jstack-1]=i;
				ir=j-1;
			} else {
				istack[jstack]=j-1;
				istack[jstack-1]=l;
				l=i;
			}
		}
	}
	free_lvector(istack,1,INDEXX_NSTACK);
}
#undef INDEXX_M
#undef INDEXX_NSTACK
#undef INDEXX_SWAP
#undef NRANSI
/* (C) Copr. 1986-92 Numerical Recipes Software *(5$r. */
