#include <math.h>
#define NRANSI
#include "nrutil.h"


/* macros to maintain precision
 * the macros of nrutil.h use float precision
 */
#ifndef MY_ABS
#define	MY_ABS(a)	        ( (a) >= 0.0 ? (a) : (-1.0)*(a) )
#endif

#ifndef MY_SQR
#define MY_SQR(a)               ( (a)*(a) )
#endif

double pythag_d(double a, double b)
     /* 
      * pythag with double arithmetic
      */
{
	double absa,absb;
	absa=MY_ABS(a);
	absb=MY_ABS(b);
	if (absa > absb) return absa*sqrt(1.0+MY_SQR(absb/absa));
	else return (absb == 0.0 ? 0.0 : absb*sqrt(1.0+MY_SQR(absa/absb)));
}
#undef MY_ABS
#undef MY_SQR
#undef NRANSI
/* (C) Copr. 1986-92 Numerical Recipes Software *(5$r. */
