#include <math.h>
#define NRANSI
#include "nrutil.h"
#include "pythag_d.c"


/* macros to maintain precision
 * the macros of nrutil.h use float precision
 */
#ifndef MY_ABS
#define	MY_ABS(a)	 ( (a) >= 0.0 ? (a) : (-1.0)*(a) )
#endif
#ifndef MY_SIGN
#define MY_SIGN(a,b)     ( (b) >= 0.0 ? MY_ABS(a) : (-1.0)*MY_ABS(a) )
#endif


void tqli_il_d_ul(double d[], double e[], int n, double **z, 
		  int itmax)
{
	double pythag_d(double a, double b);
	int m,l,iter,i,k;
	double s,r,p,g,f,dd,c,b;

	for (i=2;i<=n;i++) e[i-1]=e[i];
	e[n]=0.0;
	for (l=1;l<=n;l++) {
		iter=0;
		do {
			for (m=l;m<=n-1;m++) {
				dd=MY_ABS(d[m])+MY_ABS(d[m+1]);
				if ((double)(MY_ABS(e[m])+dd) == dd) break;
			}
			if (m != l) {
				if (iter++ == itmax) nrerror("Too many iterations in tqli");
				g=(d[l+1]-d[l])/(2.0*e[l]);
				r=pythag_d(g,1.0);
				g=d[m]-d[l]+e[l]/(g+MY_SIGN(r,g));
				s=c=1.0;
				p=0.0;
				for (i=m-1;i>=l;i--) {
					f=s*e[i];
					b=c*e[i];
					e[i+1]=(r=pythag_d(f,g));
					if (r == 0.0) {
						d[i+1] -= p;
						e[m]=0.0;
						break;
					}
					s=f/r;
					c=g/r;
					g=d[i+1]-p;
					r=(d[i]-g)*s+2.0*c*b;
					d[i+1]=g+(p=s*r);
					g=c*r-b;
					for (k=1;k<=n;k++) {
						f=z[k][i+1];
						z[k][i+1]=s*z[k][i]+c*f;
						z[k][i]=c*z[k][i]-s*f;
					}
				}
				if (r == 0.0 && i >= l) continue;
				d[l] -= p;
				e[l]=g;
				e[m]=0.0;
			}
		} while (m != l);
	}
}
#undef MY_SIGN
#undef MY_ABS
#undef NRANSI
/* (C) Copr. 1986-92 Numerical Recipes Software *(5$r. */
